#!/usr/bin/env python

import sqlite3
import sys
import cgi
import cgitb
import datetime

# global variables
speriod=(15*60)-1
dbname='/home/pi/temperature/temperature.db'



# print the HTTP header
def printHTTPheader():
    print "Content-type: text/html\n\n"



# print the HTML head section
# arguments are the page title and the table for the chart
def printHTMLHead(title, table,table1):
    print "<head>"
    print "    <title>"
    print title
    print "    </title>"
    
    print_graph_script(table,table1)

    print "</head>"

def getTempNeeded():
        conn=sqlite3.connect(dbname)
        curs=conn.cursor()
        curs.execute("Select degree from tempneed")
        rows=curs.fetchall()
        conn.close()
        return rows[0][0]

def setTempNeeded(degree):
        conn=sqlite3.connect(dbname)
        curs=conn.cursor()
        curs.execute("replace into tempneed values(1,"+ degree +")")
        conn.commit()
        conn.close()

def get_tempNeedAndChauff():
        conn=sqlite3.connect(dbname)
        curs=conn.cursor()
        curs.execute("SELECT dateheure, tempneed, chauffmarcel, temp FROM temperature ORDER BY 1 desc limit 1")
        rows=curs.fetchall()
        conn.close()
        return rows

# get data from the database
# if an interval is passed, 
# return a list of records from the database
def get_data(interval):

	conn=sqlite3.connect(dbname)
	curs=conn.cursor()

	if interval == None:
		curs.execute("SELECT * FROM temperature")
    	else:
        	curs.execute("SELECT * FROM temperature WHERE dateheure>datetime('now','-%s hours')" % interval)
            #curs.execute("SELECT * FROM temperature WHERE dateheure>datetime('2015-08-30 21:30:02') AND dateheure<=datetime('2015-09-01 21:31:02')")

	rows=curs.fetchall()

	conn.close()

	return rows

# convert rows from database into a javascript table
def create_temptable(rows):
    chart_table=""
    
    for row in rows[:-1]:
        rowstr="['{0}', {1}],\n".format(convertDateTimeToUTC(str(row[0])),str(row[1]))
        chart_table+=rowstr
    
    row=rows[-1]
    rowstr="['{0}', {1}]\n".format(convertDateTimeToUTC(str(row[0])),str(row[1]))
    chart_table+=rowstr
    
    return chart_table

def convertDateTimeToUTC(dateHour):
    fmt = '%Y-%m-%d %H:%M:%S'
    dt = datetime.datetime.strptime(dateHour, fmt)
    epoch = datetime.datetime.utcfromtimestamp(0)
    delta = dt - epoch
    
    return int(delta.total_seconds()) * 1000

# convert rows from database into a javascript tab#le
def create_humiditytable(rows):
    chart_table=""
    
    for row in rows[:-1]:
        rowstr="['{0}', {1}],\n".format(convertDateTimeToUTC(str(row[0])),str(row[2]))
        chart_table+=rowstr

    row=rows[-1]
    rowstr="['{0}', {1}]\n".format(convertDateTimeToUTC(str(row[0])),str(row[2]))
    chart_table+=rowstr
    
    return chart_table

# print the javascript to generate the chart
# pass the table generated from the database info
def print_graph_script(table,table1):

	# google chart snippet
	print """
        <link href="bootstrap/css/bootstrap.css" rel="stylesheet">
        <link href="bootstrap/css/bootstrap-responsive.css" rel="stylesheet">
        <link href="bootstrap/css/style.css" rel="stylesheet">
        <script src="bootstrap/js/jquery.js"></script>
        <script src="bootstrap/js/bootstrap.js"></script>
        <script src="highcharts/js/highcharts.js"></script>
        <script src="highcharts/js/modules/exporting.js"></script>
        <!-- HTML5 shim, for IE6-8 support of HTML5 elements -->
        <!--[if lt IE 9]>
            <script src="bootstrap/js/html5shiv.js"></script>
        <![endif]-->

        <!-- Fav and touch icons -->
        <link rel="apple-touch-icon-precomposed" sizes="144x144" href="bootstrap/ico/apple-touch-icon-144-precomposed.png">
        <link rel="apple-touch-icon-precomposed" sizes="114x114" href="bootstrap/ico/apple-touch-icon-114-precomposed.png">
        <link rel="apple-touch-icon-precomposed" sizes="72x72" href="bootstrap/ico/apple-touch-icon-72-precomposed.png">
        <link rel="apple-touch-icon-precomposed" href="bootstrap/ico/apple-touch-icon-57-precomposed.png">
        <link rel="shortcut icon" href="bootstrap/ico/favicon.png">

        

	<script type="text/javascript">
        $(function () {
            
                $('#graph0').highcharts({
                    chart: {
                       type: 'line',
                       marginRight: 130,
                       marginBottom: 25,
                       className: 'skies',
                       borderWidth: 0,
                       plotShadow: true,
                       plotBackgroundImage: 'highcharts/graphics/skies.jpg',
                       plotBackgroundColor: {
                          linearGradient: [0, 0, 250, 500],
                          stops: [
                             [0, 'rgba(255, 255, 255, 1)'],
                             [1, 'rgba(255, 255, 255, 0)']
                          ]
                       },
                       plotBorderWidth: 1
                    },
                    plotOptions: {
                        area: {
                            fillColor: {
                                linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1},
                                stops: [
                                    [0, Highcharts.getOptions().colors[0]],
                                    [1, Highcharts.Color(Highcharts.getOptions().colors[0]).setOpacity(0).get('rgba')]
                                ]
                            },
                            lineWidth: 1,
                            marker: {
                                enabled: false
                            },
                            shadow: false,
                            states: {
                                hover: {
                                    lineWidth: 1
                                }
                            },
                            threshold: null
                        }
                    },                    
                    title: {
                        text: 'Temperatures sur les 2 derniers jours',
                        x: -20 
                    },
                    xAxis: {
                        type: 'datetime',
                        dateTimeLabelFormats: { // don't display the year
                            month: '%e. %b',
                            year: '%b'
                        }
                    },               
                    yAxis: {
                        title: {
                            text: 'Temperature (C)'
                        },
                        alternateGridColor: 'rgba(255, 255, 255, .5)',
                        plotLines: [{
                            value: 0,
                            width: 1,
                            color: '#808080'
                        }]
                    },
                    tooltip: {
                        valueSuffix: 'C'
                    },
                    legend: {
                        layout: 'vertical',
                        align: 'right',
                        verticalAlign: 'top',
                        x: -10,
                        y: 100,
                        borderWidth: 0
                    },
        """
	chart_code="""
                    series: [
                    {
                        type: 'area',
                        name: 'Salon',
                        data: [%s]
                    },
                    ]
                });
                $('#graph1').highcharts({
                    chart: {
                       type: 'line',
                       marginRight: 130,
                       marginBottom: 25,
                       className: 'skies',
                       borderWidth: 0,
                       plotShadow: true,
                       plotBackgroundImage: 'highcharts/graphics/skies.jpg',
                       plotBackgroundColor: {
                          linearGradient: [0, 0, 250, 500],
                          stops: [
                             [0, 'rgba(255, 255, 255, 1)'],
                             [1, 'rgba(255, 255, 255, 0)']
                          ]
                       },
                       plotBorderWidth: 1
                    },
                    plotOptions: {
                        area: {
                            fillColor: {
                                linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1},
                                stops: [
                                    [0, Highcharts.getOptions().colors[0]],
                                    [1, Highcharts.Color(Highcharts.getOptions().colors[0]).setOpacity(0).get('rgba')]
                                ]
                            },
                            lineWidth: 1,
                            marker: {
                                enabled: false
                            },
                            shadow: false,
                            states: {
                                hover: {
                                    lineWidth: 1
                                }
                            },
                            threshold: null
                        }
                    },                    
                    title: {
                        text: 'Temperatures sur un mois',
                        x: -20 //center
                    },
                    xAxis: {
                        type: 'datetime',
                        dateTimeLabelFormats: { // don't display the year
                            month: '',
                            year: ''
                        }
                    },               
                    yAxis: {
                        title: {
                            text: 'humidity '
                        },
                        alternateGridColor: 'rgba(255, 255, 255, .5)',
                        plotLines: [{
                            value: 0,
                            width: 1,
                            color: '#808080'
                        }]
                    },
                    tooltip: {
                        valueSuffix: 'C'
                    },
                    legend: {
                        layout: 'vertical',
                        align: 'right',
                        verticalAlign: 'top',
                        x: -10,
                        y: 100,
                        borderWidth: 0
                    },
                    series: [
                    {
                        type: 'area',
                        name: 'Salon',
                        data: [%s],
                    },
                    ]
                });        });
    </script>"""

#        <script type="text/javascript" src="https://www.google.com/jsapi"></script>
#	<script type="text/javascript">
#	google.load("visualization", "1", {packages:["corechart"]});
#	google.setOnLoadCallback(drawChart);
#	google.setOnLoadCallback(drawChart1);
#	var dataTemp = [
#          ['Time', 'Temperature'],
#	%s
#        ];
#        var dataHumidity = [
#          ['Time', 'Humidity'],
#	%s
#        ];
#
#
#	function drawChart() {
#		var data = google.visualization.arrayToDataTable(dataTemp);
#		
#		var options = {
#          	title: 'Temperature'
#        };
#	
#        var chart = new google.visualization.LineChart(document.getElementById('chart_div'));
#        chart.draw(data, options);
#      	}
#
#	function drawChart1() {
#		var data1 = google.visualization.arrayToDataTable(dataHumidity);
#		
#		var options = {
#          	title: 'Humidity'
#        };
#	
#        var chart = new google.visualization.LineChart(document.getElementById('chart_div1'));
#        chart.draw(data1, options);
#      	}
#    	</script>"""

    	print chart_code % (table,table1)




# print the div that contains the graph
def show_graph():
    #print "<h2>Temperature Chart</h2>"
    #print '<div id="chart_div" style="width: 900px; height: 500px;"></div>'
    #print '<div id="chart_div1" style="width: 900px; height: 500px;"></div>'
    print """
    <!--
    sarousel
    ================================================== -->
    <div id="myCarousel" class="carousel slide">
      <div class="carousel-inner">
        <div class="item active">
          <div id="graph0" class="container">
          </div>
        </div>
        <div class="item">
          <div id="graph1" class="container">
          </div>
        </div>
      </div>
      <a class="left carousel-control" href="#myCarousel" data-slide="prev">&lsaquo;</a>
      <a class="right carousel-control" href="#myCarousel" data-slide="next">&rsaquo;</a>
    </div><!-- /.carousel -->
    """


# connect to the db and show some stats
# argument option is the number of hours
def show_stats(option):

    conn=sqlite3.connect(dbname)
    curs=conn.cursor()

    if option is None:
        option = str(24)

    curs.execute("SELECT dateheure,max(temp) FROM temperature WHERE dateheure>datetime('now','-%s hour') AND dateheure<=datetime('now')" % option)
#    curs.execute("SELECT dateheure,max(temp) FROM temperature WHERE dateheure>datetime('2013-09-19 21:30:02','-%s hour') AND dateheure<=datetime('2013-09-19 21:31:02')" % option)
    rowmax=curs.fetchone()
    rowstrmax="{0}&nbsp&nbsp&nbsp{1}C".format(str(rowmax[0]),str(rowmax[1]))

    curs.execute("SELECT dateheure,min(temp) FROM temperature WHERE dateheure>datetime('now','-%s hour') AND dateheure<=datetime('now')" % option)
#    curs.execute("SELECT dateheure,min(temp) FROM temperature WHERE dateheure>datetime('2013-09-19 21:30:02','-%s hour') AND dateheure<=datetime('2013-09-19 21:31:02')" % option)
    rowmin=curs.fetchone()
    rowstrmin="{0}&nbsp&nbsp&nbsp{1}C".format(str(rowmin[0]),str(rowmin[1]))

    curs.execute("SELECT avg(temp) FROM temperature WHERE dateheure>datetime('now','-%s hour') AND dateheure<=datetime('now')" % option)
#    curs.execute("SELECT avg(temp) FROM temperature WHERE dateheure>datetime('2013-09-19 21:30:02','-%s hour') AND dateheure<=datetime('2013-09-19 21:31:02')" % option)
    rowavg=curs.fetchone()


    print "<hr>"


    print "<h2>Minumum temperature&nbsp</h2>"
    print rowstrmin
    print "<h2>Maximum temperature</h2>"
    print rowstrmax
    print "<h2>Average temperature</h2>"
    print rowavg #"%.3f" % rowavg+"C"
    print "<h2>Etat tempNeed et chauffMarcel:</h2>"
    getState = get_tempNeedAndChauff()
    print "chauffMArcel: {1} and tempNow/tempNeed: {2}/{0}C".format(str(getState[0][1]),str(getState[0][2]),str(getState[0][3]))
#    print "<br>"
#    print "<h2>set temp</h2>"
#    getTEMPNEED = getTempNeeded()
#    print "get Temp:"+str(getTempNeeded())
#    print "set Temp:<select name='shipping'> <option value='1'>19</option> <option value='2'>20</option> <option value='3'>21</option> <option value='4'>22</option><option value='5'>23</option></select>"
#    print "<hr>"

#    print "<h2>In the last hour:</h2>"
#   print "<table>"
#    print "<tr><td><strong>Date/Time</strong></td><td><strong>Temperature</strong></td></tr>"

#    rows=curs.execute("SELECT * FROM temperature WHERE dateheure>datetime('now','-1 hour') AND dateheure<=datetime('now')")
    #rows=curs.execute("SELECT * FROM temperature WHERE dateheure>datetime('2013-09-19 21:30:02','-1 hour') AND dateheure<=datetime('2013-09-19 21:31:02')")
#    for row in rows:
#        rowstr="<tr><td>{0}&emsp;&emsp;</td><td>{1}C</td></tr>".format(str(row[0]),str(row[1]))
#        print rowstr
#    print "</table>"

#    print "<hr>"

    conn.close()




def print_time_selector(option):

    print """<form action="/cgi-bin/temperature.py" method="POST">
        Show the temperature logs for  
        <select name="timeinterval">"""


    if option is not None:

        if option == "6":
            print "<option value=\"6\" selected=\"selected\">the last 6 hours</option>"
        else:
            print "<option value=\"6\">the last 6 hours</option>"

        if option == "12":
            print "<option value=\"12\" selected=\"selected\">the last 12 hours</option>"
        else:
            print "<option value=\"12\">the last 12 hours</option>"

        if option == "24":
            print "<option value=\"24\" selected=\"selected\">the last 24 hours</option>"
        else:
            print "<option value=\"24\">the last 24 hours</option>"

    else:
        print """<option value="6">the last 6 hours</option>
            <option value="12">the last 12 hours</option>
            <option value="24" selected="selected">the last 24 hours</option>"""

    print """        </select>
        <input type="submit" value="Display">
    </form>"""


# check that the option is valid
# and not an SQL injection
def validate_input(option_str):
    # check that the option string represents a number
    if option_str.isalnum():
        # check that the option is within a specific range
        if int(option_str) > 0 and int(option_str) <= 24:
            return option_str
        else:
            return None
    else: 
        return None


#return the option passed to the script
def get_option():
    form=cgi.FieldStorage()
    if "timeinterval" in form:
        option = form["timeinterval"].value
        return validate_input (option)
    else:
        return None




# main function
# This is where the program starts 
def main():

    cgitb.enable()

    # get options that may have been passed to this script
    option=get_option()

    if option is None:
        option = str(12)

    # get data from the database
    records=get_data(option)

    # print the HTTP header
    printHTTPheader()

    if len(records) != 0:
        # convert the data into a table
        temperature=create_temptable(records)
        humidity=create_humiditytable(records)
    else:
        print "No data found"
        return

    # start printing the page
    print "<html>"
    # print the head section including the table
    # used by the javascript for the chart
    printHTMLHead("Raspberry Pi Temperature Logger", temperature, humidity)

    # print the page body
    print "<body>"
    print "<h1>Raspberry Pi Temperature Logger</h1>"
    print "<hr>"
    print_time_selector(option)
    show_graph()
    dateNow = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    print """
    <!-- Three columns of text -->
    <div class="container marketing">
        <div class="row">
        <div class="span4">
            <h2>"""
    print dateNow
    print """        
            </h2>
            <br/><br/>
            <img src='images/soleil.jpg' width=30 height=30/>           
        </div>
        <div class='span4'>
            <h2><br/>-</h2><br/>      
        </div>
    </div>
    <script>
      !function ($) {
        $(function(){
          // carousel demo
          $('#myCarousel').carousel()
        })
      }(window.jQuery)
    </script>
"""
    print "</body>"
    print "</html>"

    sys.stdout.flush()

if __name__=="__main__":
    main()




